<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
  <script src="socket.io/socket.io.js"></script>
  <script>
    let clientSocket;
    window.onload = () => {

      const otherPeers = [];
      const pc = new webkitRTCPeerConnection({"iceServers": [
        {"url": "stun:provserver.televolution.net"},
        {"url": "stun:stun.ekiga.net"}
      ]})
      let offSent = false;
      let stream = null;

      function setupClient() {
        clientSocket = io.connect('localhost:8111');
        clientSocket.on('client_socket', (data) => {
          if(data === '0') {
            pc.createOffer(getOfferDescription);
            offerSent = true;
          } else if (data.type === 'description') {
            if(!offerSent) {
              pc.setRemoteDescription(new RTCSessionDescription(data.info));
              pc.createAnswer(gotAnswerDescription)
            } else {
              pc.setRemoteDescription(new RTCSessionDescription(data.info));
            }
          } else if (data.type === 'candidate') {
            pc.addIceCandidate(new RTCIceCandidate(data.info))
          } else if (data === 'reset') {
            pc.close();
            alert('user candidate exit')
          }
        }) 

        function getOfferDescription(desc) {
          pc.setLocalDescription(desc);
          clientSocket.emit('server_socket', {type: 'description', info: desc});
        }

        function getAnswerDescription(desc) {
          pc.setLocalDescription(desc);
          clientSocket.emit('server_socket', {type: 'description', info: desc});
        }

        pc.onicecandidate = function(event) {
          if(event.candidate) {
            clientSocket.emit('server_socket', {type: 'candidate', info: event.candidate});
          }
        }

        pc.onaddstream = function(event) {
          document.getElementById('videostreamOutput').src = webkitUrl.createObjectURL(event.stream)
        }

        pc.onerror = function(error) {
          console.log('Error:', error);
        }
      }
      
      // myVideo
      (function(){
        navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia;
        window.URL = window.url || window.webkitURL;

        navigator.getUserMedia({ video: true, audio: true }, (localMediaStream) => {  
          const myVideoElement = document.getElementById('myStream');
          if (typeof myVideoElement.srcObject === 'object') {
            myVideoElement.srcObject = localMediaStream;
          } else {
            myVideoElement.src = window.URL.createObjectURL(localMediaStream);
          }
          myVideoElement.style.display = "inline";
          pc.addStream(localMediaStream);
          console.log(localMediaStream);
          setupClient();

        }, () => {alert('error')})
      })();
    } 
  </script>
</head>
<body>
  <video id="videostreamOutput" style="display: none" width="300" autoplay src=""></video>
  <video id="myStream" style="display: none" width="250" autoplay src=""></video>
</body>
</html>